#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Syncfusion.Windows.Forms.Diagram.Samples.DrawShapes
{
	/// <summary>
	/// This Sample will help you put the Diagram to a ReadOnly state.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.ToolBarButton toolBarButtonSelect;
		private System.Windows.Forms.ToolBarButton toolBarButtonDrawLine;
		private System.Windows.Forms.ToolBarButton toolBarButtonDrawPolyline;
		private System.Windows.Forms.ToolBarButton toolBarButtonDrawOrthogonalLine;
		private System.Windows.Forms.ToolBarButton toolBarButtonDrawRectangle;
		private System.Windows.Forms.ToolBarButton toolBarButtonDrawRoundRect;
		private System.Windows.Forms.ToolBarButton toolBarButtonDrawPolygon;
		private System.Windows.Forms.ToolBarButton toolBarButtonDrawCurve;
		private System.Windows.Forms.ToolBarButton toolBarButtonDrawClosedCurve;
		private System.Windows.Forms.ToolBarButton toolBarButtonDrawArc;
		private System.Windows.Forms.Panel panel1;
		private Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor propertyEditor1;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.ToolBarButton toolBarButtonPan;
		private Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView paletteGroupView1;
		private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram1;
		private System.Windows.Forms.ToolBarButton toolBarButtonZoom;

		public MainForm()
		{
			InitializeComponent();
			this.diagram1.ChildrenChanging +=new NodeCollectionEventHandler(diagram1_ChildrenChanging);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.toolBarButtonSelect = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonDrawLine = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonDrawPolyline = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonDrawOrthogonalLine = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonDrawRectangle = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonDrawRoundRect = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonDrawPolygon = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonDrawCurve = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonDrawClosedCurve = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonDrawArc = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonPan = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonZoom = new System.Windows.Forms.ToolBarButton();
			this.panel1 = new System.Windows.Forms.Panel();
			this.diagram1 = new Syncfusion.Windows.Forms.Diagram.Controls.Diagram();
			this.paletteGroupView1 = new Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView();
			this.propertyEditor1 = new Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.diagram1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.diagram1.Model)).BeginInit();
			this.SuspendLayout();
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Fuchsia;
			// 
			// toolBar1
			// 
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.toolBarButtonSelect,
																						this.toolBarButtonDrawLine,
																						this.toolBarButtonDrawPolyline,
																						this.toolBarButtonDrawOrthogonalLine,
																						this.toolBarButtonDrawRectangle,
																						this.toolBarButtonDrawRoundRect,
																						this.toolBarButtonDrawPolygon,
																						this.toolBarButtonDrawCurve,
																						this.toolBarButtonDrawClosedCurve,
																						this.toolBarButtonDrawArc,
																						this.toolBarButtonPan,
																						this.toolBarButtonZoom});
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.ImageList = this.imageList1;
			this.toolBar1.Location = new System.Drawing.Point(0, 0);
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(584, 28);
			this.toolBar1.TabIndex = 2;
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
			// 
			// toolBarButtonSelect
			// 
			this.toolBarButtonSelect.ImageIndex = 0;
			this.toolBarButtonSelect.Pushed = true;
			this.toolBarButtonSelect.Tag = "SelectTool";
			this.toolBarButtonSelect.ToolTipText = "Select";
			// 
			// toolBarButtonDrawLine
			// 
			this.toolBarButtonDrawLine.ImageIndex = 1;
			this.toolBarButtonDrawLine.Tag = "LineTool";
			this.toolBarButtonDrawLine.ToolTipText = "Line";
			// 
			// toolBarButtonDrawPolyline
			// 
			this.toolBarButtonDrawPolyline.ImageIndex = 2;
			this.toolBarButtonDrawPolyline.Tag = "PolyLineTool";
			this.toolBarButtonDrawPolyline.ToolTipText = "Polyline";
			// 
			// toolBarButtonDrawOrthogonalLine
			// 
			this.toolBarButtonDrawOrthogonalLine.ImageIndex = 3;
			this.toolBarButtonDrawOrthogonalLine.Tag = "OrthogonalLineTool";
			this.toolBarButtonDrawOrthogonalLine.ToolTipText = "Orthogonal Line";
			// 
			// toolBarButtonDrawRectangle
			// 
			this.toolBarButtonDrawRectangle.ImageIndex = 4;
			this.toolBarButtonDrawRectangle.Tag = "RectangleTool";
			this.toolBarButtonDrawRectangle.ToolTipText = "Rectangle";
			// 
			// toolBarButtonDrawRoundRect
			// 
			this.toolBarButtonDrawRoundRect.ImageIndex = 5;
			this.toolBarButtonDrawRoundRect.Tag = "RoundRectTool";
			this.toolBarButtonDrawRoundRect.ToolTipText = "Rounded Rectangle";
			// 
			// toolBarButtonDrawPolygon
			// 
			this.toolBarButtonDrawPolygon.ImageIndex = 6;
			this.toolBarButtonDrawPolygon.Tag = "PolygonTool";
			this.toolBarButtonDrawPolygon.ToolTipText = "Polygon";
			// 
			// toolBarButtonDrawCurve
			// 
			this.toolBarButtonDrawCurve.ImageIndex = 7;
			this.toolBarButtonDrawCurve.Tag = "CurveTool";
			this.toolBarButtonDrawCurve.ToolTipText = "Curve";
			// 
			// toolBarButtonDrawClosedCurve
			// 
			this.toolBarButtonDrawClosedCurve.ImageIndex = 8;
			this.toolBarButtonDrawClosedCurve.Tag = "ClosedCurveTool";
			this.toolBarButtonDrawClosedCurve.ToolTipText = "Closed Curve";
			// 
			// toolBarButtonDrawArc
			// 
			this.toolBarButtonDrawArc.ImageIndex = 9;
			this.toolBarButtonDrawArc.Tag = "ArcTool";
			this.toolBarButtonDrawArc.ToolTipText = "Arc";
			// 
			// toolBarButtonPan
			// 
			this.toolBarButtonPan.ImageIndex = 10;
			this.toolBarButtonPan.Tag = "PanTool";
			// 
			// toolBarButtonZoom
			// 
			this.toolBarButtonZoom.ImageIndex = 11;
			this.toolBarButtonZoom.Tag = "ZoomTool";
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.diagram1);
			this.panel1.Controls.Add(this.propertyEditor1);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 28);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(584, 426);
			this.panel1.TabIndex = 4;
			// 
			// diagram1
			// 
			this.diagram1.AllowDrop = true;
			// 
			// diagram1.Controller
			// 
			this.diagram1.Controller.MaxHistory = 256;
			this.diagram1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.diagram1.HScroll = true;
			this.diagram1.LayoutManager = null;
			this.diagram1.Location = new System.Drawing.Point(0, 0);
			// 
			// diagram1.Model
			// 
			this.diagram1.Model.BackgroundStyle.Color = System.Drawing.Color.White;
			this.diagram1.Model.BackgroundStyle.ForeColor = System.Drawing.Color.White;
			this.diagram1.Model.HeaderFooterData.Footer.Bounds.Width = 650F;
			this.diagram1.Model.HeaderFooterData.Header.Bounds.Width = 650F;
			this.diagram1.Model.Height = 1056F;
			this.diagram1.Model.Name = "Model";
			this.diagram1.Model.ShadowStyle.AlphaFactor = 128;
			this.diagram1.Model.ShadowStyle.Color = System.Drawing.Color.LightGray;
			this.diagram1.Model.ShadowStyle.OffsetX = 6F;
			this.diagram1.Model.ShadowStyle.OffsetY = 6F;
			this.diagram1.Model.ShadowStyle.Visible = false;
			this.diagram1.Model.Width = 816F;
			this.diagram1.Name = "diagram1";
			this.diagram1.Size = new System.Drawing.Size(424, 426);
			this.diagram1.SmartSizeBox = false;
			this.diagram1.TabIndex = 5;
			this.diagram1.Text = "diagram1";
			this.diagram1.VScroll = true;
			// 
			// paletteGroupView1
			// 
			this.paletteGroupView1.ButtonView = true;
			this.paletteGroupView1.Location = new System.Drawing.Point(2, 24);
			this.paletteGroupView1.Name = "paletteGroupView1";
			this.paletteGroupView1.SelectedItem = 0;
			this.paletteGroupView1.Size = new System.Drawing.Size(116, 400);
			this.paletteGroupView1.TabIndex = 0;
			this.paletteGroupView1.Text = "paletteGroupView1";
			this.paletteGroupView1.LoadPalette(System.Reflection.Assembly.GetAssembly(typeof(Syncfusion.Windows.Forms.Diagram.Samples.DrawShapes.MainForm)), "Syncfusion.Windows.Forms.Diagram.Samples.DrawShapes.MainForm", "paletteGroupView1.Palette");
			// 
			// propertyEditor1
			// 
			this.propertyEditor1.Diagram = this.diagram1;
			this.propertyEditor1.Dock = System.Windows.Forms.DockStyle.Right;
			this.propertyEditor1.Location = new System.Drawing.Point(424, 0);
			this.propertyEditor1.Name = "propertyEditor1";
			this.propertyEditor1.Size = new System.Drawing.Size(160, 426);
			this.propertyEditor1.TabIndex = 1;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(584, 454);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.toolBar1);
			this.Name = "MainForm";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
			this.Text = "Draw Shapes";
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.diagram1.Model)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.diagram1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if(sender is ToolBar)
			{
				ToolBar tbsender = sender as ToolBar;
				foreach(ToolBarButton btn in tbsender.Buttons)
				{
					btn.Pushed = false;
				}
			}
			string toolName = (string) e.Button.Tag;
			Tool toolToActivate = this.diagram1.Controller.GetTool( toolName );

			if( toolToActivate != null && (toolToActivate is PanTool ||toolToActivate is ZoomTool))
			{
				toolToActivate.SingleActionTool = false;
				this.diagram1.ActivateTool(toolName);
				e.Button.Pushed = true;
			}
		}
		private void MainForm_Load(object sender, System.EventArgs e)
		{
			this.diagram1.LoadBinary("../../shapes.edd");		

			// Restrict the nodes from moving using EditStyle.AllowMove property.

			foreach(INode node in this.diagram1.Model.Nodes)
			{
				if(node is Symbol)
				{
					Symbol newSym = node as Symbol;
					newSym.EditStyle.AllowMove = false;
				}
				else if(node is Link)
				{
					Link lnk = node as Link;
					lnk.EditStyle.AllowSelect = false;
				}
			}
			this.diagram1.Controller.Model.UpdateViews();
		}
		private void diagram1_ChildrenChanging(object sender, NodeCollectionEventArgs evtArgs)
		{
			// Restrict inserting new Symbols.
			if((evtArgs.ChangeType == CollectionExChangeType.Insert))
				evtArgs.Cancel = true;
			// Restrict deleting the Symbols.
			else if(evtArgs.ChangeType == CollectionExChangeType.Remove)
				evtArgs.Cancel = true;
		}
	}
}
